---------------------------------------------------------------------------------------
-- Title          : Wishbone slave core for TDC
---------------------------------------------------------------------------------------
-- File           : tdc_channel_wb.vhd
-- Author         : auto-generated by wbgen2 from tdc_channel_wb.wb
-- Created        : Tue Sep 11 22:15:48 2018
-- Standard       : VHDL'87
---------------------------------------------------------------------------------------
-- THIS FILE WAS GENERATED BY wbgen2 FROM SOURCE FILE tdc_channel_wb.wb
-- DO NOT HAND-EDIT UNLESS IT'S ABSOLUTELY NECESSARY!
---------------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use work.wishbone_pkg.all;

use work.tdc_wbgen2_pkg.all;


entity tdc_channel_wb is
port (
  rst_n_i                                  : in     std_logic;
  clk_sys_i                                : in     std_logic;
  slave_i                                  : in     t_wishbone_slave_in;
  slave_o                                  : out    t_wishbone_slave_out;
  int_o                                    : out    std_logic;
  regs_i                                   : in     t_tdc_in_registers;
  regs_o                                   : out    t_tdc_out_registers
);
end tdc_channel_wb;

architecture syn of tdc_channel_wb is

signal tdc_csr_rst_dly0                         : std_logic      ;
signal tdc_csr_rst_int                          : std_logic      ;
signal tdc_csr_ro_en_int                        : std_logic      ;
signal tdc_calr_cal_mode_int                    : std_logic      ;
signal tdc_calr_cal_step_int                    : std_logic_vector(14 downto 0);
signal tdc_calr_cal_offset_int                  : std_logic_vector(14 downto 0);
signal tdc_raw_csr_ack_dly0                     : std_logic      ;
signal tdc_raw_csr_ack_int                      : std_logic      ;
signal tdc_raw_bank_int                         : std_logic_vector(7 downto 0);
signal tdc_luta_int                             : std_logic_vector(15 downto 0);
signal ack_sreg                                 : std_logic_vector(9 downto 0);
signal rddata_reg                               : std_logic_vector(31 downto 0);
signal wrdata_reg                               : std_logic_vector(31 downto 0);
signal bwsel_reg                                : std_logic_vector(3 downto 0);
signal rwaddr_reg                               : std_logic_vector(3 downto 0);
signal ack_in_progress                          : std_logic      ;
signal wr_int                                   : std_logic      ;
signal rd_int                                   : std_logic      ;
signal allones                                  : std_logic_vector(31 downto 0);
signal allzeros                                 : std_logic_vector(31 downto 0);

begin
-- Some internal signals assignments
wrdata_reg <= slave_i.dat;
-- 
-- Main register bank access process.
process (clk_sys_i, rst_n_i)
begin
  if (rst_n_i = '0') then 
    ack_sreg <= "0000000000";
    ack_in_progress <= '0';
    rddata_reg <= "00000000000000000000000000000000";
    tdc_csr_rst_int <= '0';
    tdc_csr_ro_en_int <= '0';
    tdc_calr_cal_mode_int <= '0';
    tdc_calr_cal_step_int <= "000000000000000";
    tdc_calr_cal_offset_int <= "000000000000000";
    tdc_raw_csr_ack_int <= '0';
    tdc_raw_bank_int <= "00000000";
    tdc_luta_int <= "0000000000000000";
  elsif rising_edge(clk_sys_i) then
-- advance the ACK generator shift register
    ack_sreg(8 downto 0) <= ack_sreg(9 downto 1);
    ack_sreg(9) <= '0';
    if (ack_in_progress = '1') then
      if (ack_sreg(0) = '1') then
        tdc_csr_rst_int <= '0';
        tdc_raw_csr_ack_int <= '0';
        ack_in_progress <= '0';
      else
      end if;
    else
      if ((slave_i.cyc = '1') and (slave_i.stb = '1')) then
        case rwaddr_reg(3 downto 0) is
        when "0000" => 
          if (slave_i.we = '1') then
            tdc_csr_rst_int <= wrdata_reg(0);
            tdc_csr_ro_en_int <= wrdata_reg(3);
          end if;
          rddata_reg(0) <= '0';
          rddata_reg(1) <= regs_i.csr_rdy_i;
          rddata_reg(2) <= regs_i.csr_valid_i;
          rddata_reg(3) <= tdc_csr_ro_en_int;
          rddata_reg(4) <= 'X';
          rddata_reg(5) <= 'X';
          rddata_reg(6) <= 'X';
          rddata_reg(7) <= 'X';
          rddata_reg(8) <= 'X';
          rddata_reg(9) <= 'X';
          rddata_reg(10) <= 'X';
          rddata_reg(11) <= 'X';
          rddata_reg(12) <= 'X';
          rddata_reg(13) <= 'X';
          rddata_reg(14) <= 'X';
          rddata_reg(15) <= 'X';
          rddata_reg(16) <= 'X';
          rddata_reg(17) <= 'X';
          rddata_reg(18) <= 'X';
          rddata_reg(19) <= 'X';
          rddata_reg(20) <= 'X';
          rddata_reg(21) <= 'X';
          rddata_reg(22) <= 'X';
          rddata_reg(23) <= 'X';
          rddata_reg(24) <= 'X';
          rddata_reg(25) <= 'X';
          rddata_reg(26) <= 'X';
          rddata_reg(27) <= 'X';
          rddata_reg(28) <= 'X';
          rddata_reg(29) <= 'X';
          rddata_reg(30) <= 'X';
          rddata_reg(31) <= 'X';
          ack_sreg(2) <= '1';
          ack_in_progress <= '1';
        when "0001" => 
          if (slave_i.we = '1') then
            tdc_calr_cal_mode_int <= wrdata_reg(0);
            tdc_calr_cal_step_int <= wrdata_reg(15 downto 1);
            tdc_calr_cal_offset_int <= wrdata_reg(30 downto 16);
          end if;
          rddata_reg(0) <= tdc_calr_cal_mode_int;
          rddata_reg(15 downto 1) <= tdc_calr_cal_step_int;
          rddata_reg(30 downto 16) <= tdc_calr_cal_offset_int;
          rddata_reg(31) <= 'X';
          ack_sreg(0) <= '1';
          ack_in_progress <= '1';
        when "0010" => 
          if (slave_i.we = '1') then
            tdc_raw_csr_ack_int <= wrdata_reg(1);
          end if;
          rddata_reg(0) <= regs_i.raw_csr_valid_i;
          rddata_reg(1) <= '0';
          rddata_reg(2) <= 'X';
          rddata_reg(3) <= 'X';
          rddata_reg(4) <= 'X';
          rddata_reg(5) <= 'X';
          rddata_reg(6) <= 'X';
          rddata_reg(7) <= 'X';
          rddata_reg(8) <= 'X';
          rddata_reg(9) <= 'X';
          rddata_reg(10) <= 'X';
          rddata_reg(11) <= 'X';
          rddata_reg(12) <= 'X';
          rddata_reg(13) <= 'X';
          rddata_reg(14) <= 'X';
          rddata_reg(15) <= 'X';
          rddata_reg(16) <= 'X';
          rddata_reg(17) <= 'X';
          rddata_reg(18) <= 'X';
          rddata_reg(19) <= 'X';
          rddata_reg(20) <= 'X';
          rddata_reg(21) <= 'X';
          rddata_reg(22) <= 'X';
          rddata_reg(23) <= 'X';
          rddata_reg(24) <= 'X';
          rddata_reg(25) <= 'X';
          rddata_reg(26) <= 'X';
          rddata_reg(27) <= 'X';
          rddata_reg(28) <= 'X';
          rddata_reg(29) <= 'X';
          rddata_reg(30) <= 'X';
          rddata_reg(31) <= 'X';
          ack_sreg(2) <= '1';
          ack_in_progress <= '1';
        when "0011" => 
          if (slave_i.we = '1') then
            tdc_raw_bank_int <= wrdata_reg(7 downto 0);
          end if;
          rddata_reg(7 downto 0) <= tdc_raw_bank_int;
          rddata_reg(8) <= 'X';
          rddata_reg(9) <= 'X';
          rddata_reg(10) <= 'X';
          rddata_reg(11) <= 'X';
          rddata_reg(12) <= 'X';
          rddata_reg(13) <= 'X';
          rddata_reg(14) <= 'X';
          rddata_reg(15) <= 'X';
          rddata_reg(16) <= 'X';
          rddata_reg(17) <= 'X';
          rddata_reg(18) <= 'X';
          rddata_reg(19) <= 'X';
          rddata_reg(20) <= 'X';
          rddata_reg(21) <= 'X';
          rddata_reg(22) <= 'X';
          rddata_reg(23) <= 'X';
          rddata_reg(24) <= 'X';
          rddata_reg(25) <= 'X';
          rddata_reg(26) <= 'X';
          rddata_reg(27) <= 'X';
          rddata_reg(28) <= 'X';
          rddata_reg(29) <= 'X';
          rddata_reg(30) <= 'X';
          rddata_reg(31) <= 'X';
          ack_sreg(0) <= '1';
          ack_in_progress <= '1';
        when "0100" => 
          if (slave_i.we = '1') then
          end if;
          rddata_reg(31 downto 0) <= regs_i.raw_taps_i;
          ack_sreg(0) <= '1';
          ack_in_progress <= '1';
        when "0101" => 
          if (slave_i.we = '1') then
            tdc_luta_int <= wrdata_reg(15 downto 0);
          end if;
          rddata_reg(15 downto 0) <= tdc_luta_int;
          rddata_reg(16) <= 'X';
          rddata_reg(17) <= 'X';
          rddata_reg(18) <= 'X';
          rddata_reg(19) <= 'X';
          rddata_reg(20) <= 'X';
          rddata_reg(21) <= 'X';
          rddata_reg(22) <= 'X';
          rddata_reg(23) <= 'X';
          rddata_reg(24) <= 'X';
          rddata_reg(25) <= 'X';
          rddata_reg(26) <= 'X';
          rddata_reg(27) <= 'X';
          rddata_reg(28) <= 'X';
          rddata_reg(29) <= 'X';
          rddata_reg(30) <= 'X';
          rddata_reg(31) <= 'X';
          ack_sreg(0) <= '1';
          ack_in_progress <= '1';
        when "0110" => 
          if (slave_i.we = '1') then
          end if;
          rddata_reg(31 downto 0) <= regs_i.lutd_i;
          ack_sreg(0) <= '1';
          ack_in_progress <= '1';
        when "0111" => 
          if (slave_i.we = '1') then
          end if;
          rddata_reg(31 downto 0) <= regs_i.fcr_i;
          ack_sreg(0) <= '1';
          ack_in_progress <= '1';
        when "1000" => 
          if (slave_i.we = '1') then
          end if;
          rddata_reg(31 downto 0) <= regs_i.fcsr_i;
          ack_sreg(0) <= '1';
          ack_in_progress <= '1';
        when others =>
-- prevent the slave from hanging the bus on invalid address
          ack_in_progress <= '1';
          ack_sreg(0) <= '1';
        end case;
      end if;
    end if;
  end if;
end process;


-- Drive the data output bus
slave_o.dat <= rddata_reg;
-- Reset
process (clk_sys_i, rst_n_i)
begin
  if (rst_n_i = '0') then 
    tdc_csr_rst_dly0 <= '0';
    regs_o.csr_rst_o <= '0';
  elsif rising_edge(clk_sys_i) then
    tdc_csr_rst_dly0 <= tdc_csr_rst_int;
    regs_o.csr_rst_o <= tdc_csr_rst_int and (not tdc_csr_rst_dly0);
  end if;
end process;


-- Ready
-- TS valid
-- Enable ring oscillator
regs_o.csr_ro_en_o <= tdc_csr_ro_en_int;
-- Calibration mode select
regs_o.calr_cal_mode_o <= tdc_calr_cal_mode_int;
-- Calibration step select
regs_o.calr_cal_step_o <= tdc_calr_cal_step_int;
-- Calibration offset select
regs_o.calr_cal_offset_o <= tdc_calr_cal_offset_int;
-- TS valid
-- TS ack
process (clk_sys_i, rst_n_i)
begin
  if (rst_n_i = '0') then 
    tdc_raw_csr_ack_dly0 <= '0';
    regs_o.raw_csr_ack_o <= '0';
  elsif rising_edge(clk_sys_i) then
    tdc_raw_csr_ack_dly0 <= tdc_raw_csr_ack_int;
    regs_o.raw_csr_ack_o <= tdc_raw_csr_ack_int and (not tdc_raw_csr_ack_dly0);
  end if;
end process;


-- raw bank select
regs_o.raw_bank_o <= tdc_raw_bank_int;
-- raw taps
-- Address
regs_o.luta_o <= tdc_luta_int;
-- Data
-- Result
-- Result
rwaddr_reg <= slave_i.adr(5 downto 2);
slave_o.stall <= (not ack_sreg(0)) and (slave_i.stb and slave_i.cyc);
slave_o.err <= '0';
slave_o.rty <= '0';
-- ACK signal generation. Just pass the LSB of ACK counter.
slave_o.ack <= ack_sreg(0);
end syn;
