library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity tdc_order_picker is
  generic(
    g_RANGE : integer := 5
    );
  port(
    clk_i : in std_logic;
    rst_i : in std_logic;
    cfg_i : in std_logic_vector(2*g_RANGE downto 0);
    we_i  : in std_logic;

    unsorted_i : in  std_logic_vector(2*g_RANGE downto 0);
    picked_o   : out std_logic
    );
end entity;

architecture rtl of tdc_order_picker is

  signal mask : std_logic_vector(2*g_RANGE downto 0);
begin

  process(clk_i)
  begin
    if rising_edge(clk_i) then
      if rst_i = '0' then
        mask <= (others => '0');
        mask(g_RANGE) <= '1';
      elsif we_i = '1' then
        mask <= cfg_i;
      end if;
    end if;
  end process;


  picked_o <= '0' when unsigned(mask and unsorted_i) = 0 else '1';

end rtl;

