
-- This file was autogenerated by ordertaps.py

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

library work;
use work.tdc_package.all;

entity tdc_ordertaps is
    generic(
      g_WIDTH: positive;
      g_LUT_ADDR_BITS : positive := 10;
      g_RANGE : integer := 2
      );
    port(
      clk_i : in std_logic;
      rst_i : in std_logic;
      
      lut_addr_i : in std_logic_vector(g_LUT_ADDR_BITS-1 downto 0) := (others => '0');
      lut_data_i : in std_logic_vector(2*g_RANGE downto 0) := (others => '0');
      lut_we_i : in std_logic := '0';
      
      unsorted_i : in std_logic_vector(4*g_WIDTH-1 downto 0);
      sorted_o   : out std_logic_vector(4*g_WIDTH-1 downto 0)
    );
end entity;

architecture rtl of tdc_ordertaps is
  signal we : std_logic_vector(4*g_WIDTH-1 downto 0);
  signal in_vec : std_logic_vector(4*g_WIDTH-1 + 2*g_RANGE+1 downto 0);
begin

  process(unsorted_i)
  begin
    in_vec <= (others => '0');
    in_vec( 4*g_WIDTH-1+g_RANGE-1 downto g_RANGE-1 ) <= unsorted_i;
  end process;
  
  gen_pickers: for i in 0 to g_WIDTH*4 -1 generate

    process(lut_we_i, lut_addr_i) begin
      if TO_INTEGER(unsigned(lut_addr_i)) = i then
        we(i) <= '1';
      else
        we(i) <= '0';
      end if;
    end process;

    cmp_picker: entity work.tdc_order_picker
      generic map (
        g_RANGE => g_RANGE)
      port map (
        clk_i      => clk_i,
        rst_i => rst_i,
        cfg_i      => lut_data_i,
        we_i       => we(i),
        unsorted_i => in_vec(i + 2*g_RANGE downto i),
        picked_o   => sorted_o(i));
    
  end generate gen_pickers;
  
  
end architecture;

