---------------------------------------------------------------------------------------
-- Title          : Wishbone slave core for TDC
---------------------------------------------------------------------------------------
-- File           : tdc_wbgen2_pkg.vhd
-- Author         : auto-generated by wbgen2 from tdc_channel_wb.wb
-- Created        : Tue Sep 11 22:15:48 2018
-- Standard       : VHDL'87
---------------------------------------------------------------------------------------
-- THIS FILE WAS GENERATED BY wbgen2 FROM SOURCE FILE tdc_channel_wb.wb
-- DO NOT HAND-EDIT UNLESS IT'S ABSOLUTELY NECESSARY!
---------------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use work.wishbone_pkg.all;

package tdc_wbgen2_pkg is
  
  
  -- Input registers (user design -> WB slave)
  
  type t_tdc_in_registers is record
    csr_rdy_i                                : std_logic;
    csr_valid_i                              : std_logic;
    raw_csr_valid_i                          : std_logic;
    raw_taps_i                               : std_logic_vector(31 downto 0);
    lutd_i                                   : std_logic_vector(31 downto 0);
    fcr_i                                    : std_logic_vector(31 downto 0);
    fcsr_i                                   : std_logic_vector(31 downto 0);
  end record;
  
  constant c_tdc_in_registers_init_value: t_tdc_in_registers := (
    csr_rdy_i => '0',
    csr_valid_i => '0',
    raw_csr_valid_i => '0',
    raw_taps_i => (others => '0'),
    lutd_i => (others => '0'),
    fcr_i => (others => '0'),
    fcsr_i => (others => '0')
  );
  
  -- Output registers (WB slave -> user design)
  
  type t_tdc_out_registers is record
    csr_rst_o                                : std_logic;
    csr_ro_en_o                              : std_logic;
    calr_cal_mode_o                          : std_logic;
    calr_cal_step_o                          : std_logic_vector(14 downto 0);
    calr_cal_offset_o                        : std_logic_vector(14 downto 0);
    raw_csr_ack_o                            : std_logic;
    raw_bank_o                               : std_logic_vector(7 downto 0);
    luta_o                                   : std_logic_vector(15 downto 0);
  end record;
  
  constant c_tdc_out_registers_init_value: t_tdc_out_registers := (
    csr_rst_o => '0',
    csr_ro_en_o => '0',
    calr_cal_mode_o => '0',
    calr_cal_step_o => (others => '0'),
    calr_cal_offset_o => (others => '0'),
    raw_csr_ack_o => '0',
    raw_bank_o => (others => '0'),
    luta_o => (others => '0')
  );

function "or" (left, right: t_tdc_in_registers) return t_tdc_in_registers;
function f_x_to_zero (x:std_logic) return std_logic;
function f_x_to_zero (x:std_logic_vector) return std_logic_vector;

component tdc_channel_wb is
  port (
    rst_n_i                                  : in     std_logic;
    clk_sys_i                                : in     std_logic;
    slave_i                                  : in     t_wishbone_slave_in;
    slave_o                                  : out    t_wishbone_slave_out;
    int_o                                    : out    std_logic;
    regs_i                                   : in     t_tdc_in_registers;
    regs_o                                   : out    t_tdc_out_registers
  );
end component;

end package;

package body tdc_wbgen2_pkg is
function f_x_to_zero (x:std_logic) return std_logic is
begin
  if x = '1' then
    return '1';
  else
    return '0';
  end if;
end function;

function f_x_to_zero (x:std_logic_vector) return std_logic_vector is
  variable tmp: std_logic_vector(x'length-1 downto 0);
begin
  for i in 0 to x'length-1 loop
    if(x(i) = 'X' or x(i) = 'U') then
      tmp(i):= '0';
    else
      tmp(i):=x(i);
    end if; 
  end loop; 
  return tmp;
end function;

function "or" (left, right: t_tdc_in_registers) return t_tdc_in_registers is
  variable tmp: t_tdc_in_registers;
begin
  tmp.csr_rdy_i := f_x_to_zero(left.csr_rdy_i) or f_x_to_zero(right.csr_rdy_i);
  tmp.csr_valid_i := f_x_to_zero(left.csr_valid_i) or f_x_to_zero(right.csr_valid_i);
  tmp.raw_csr_valid_i := f_x_to_zero(left.raw_csr_valid_i) or f_x_to_zero(right.raw_csr_valid_i);
  tmp.raw_taps_i := f_x_to_zero(left.raw_taps_i) or f_x_to_zero(right.raw_taps_i);
  tmp.lutd_i := f_x_to_zero(left.lutd_i) or f_x_to_zero(right.lutd_i);
  tmp.fcr_i := f_x_to_zero(left.fcr_i) or f_x_to_zero(right.fcr_i);
  tmp.fcsr_i := f_x_to_zero(left.fcsr_i) or f_x_to_zero(right.fcsr_i);
  return tmp;
end function;

end package body;
