# and don't touch the rest unless you know what you're doing.
CROSS_COMPILE ?= riscv32-elf-

CC =		$(CROSS_COMPILE)gcc
LD =		$(CROSS_COMPILE)ld
OBJDUMP =	$(CROSS_COMPILE)objdump
OBJCOPY =	$(CROSS_COMPILE)objcopy
SIZE =		$(CROSS_COMPILE)size

CFLAGS = -g -O2 -I. -I../common -I../../include -I../include/ -mabi=ilp32 -march=rv32im -ffunction-sections -fdata-sections
OBJS += ../arch/urv/crt0.o ../arch/urv/irq.o ../arch/urv/emulate.o ../common/printf.o ../common/vsprintf-xint.o ../common/board.o ../common/uart.o
LDSCRIPT = ../arch/urv/urv.ld
LDFLAGS = -Wl,--gc-sections

$(OUTPUT): $(LDSCRIPT) $(OBJS)
	${CC} ${CFLAGS} ${LDFLAGS} -g -o  $(OUTPUT).elf -nostartfiles $(OBJS) -T $(LDSCRIPT) -lgcc -lc
	${OBJCOPY} --remove-section .smem -O binary $(OUTPUT).elf $(OUTPUT).bin
	${OBJDUMP} -S $(OUTPUT).elf  > disasm.S
#	../common/genraminit $(OUTPUT).bin > $(OUTPUT).ram
	$(SIZE) $(OUTPUT).elf

../arch/urv/emulate.o:	../arch/urv/emulate.c
	${CC} -O2 -mabi=ilp32 -march=rv32i  -c $^ -o $@ -I.

%.o:	%.S
	${CC} -mabi=ilp32 -march=rv32i -c $^ -o $@

clean:
	rm -f $(OBJS) $(OUTPUT).bin