#ifndef __BOARD_H
#define __BOARD_H

#include <stdint.h>

#define SYSTEM_CLOCK_FREQ 62500000

#define UART_BAUDRATE (SYSTEM_CLOCK_FREQ/2)

#define BASE_UART (void *)    0x00081000

static inline uint32_t board_system_freq()
{
  return SYSTEM_CLOCK_FREQ;
}

static inline void usleep(int us)
{
  int t = us * board_system_freq() / 5000000;

  while(t--) asm volatile("nop");
}

static inline uint32_t readl(uint32_t addr)
{
    return *(volatile uint32_t *)(addr);
}

static inline void writel(uint32_t data, uint32_t addr)
{
    *(volatile uint32_t *)(addr) = data;
}

#endif
